## grib-api 1.14.4

=== CMakeLists.txt ===
############################################################################################
# cmake options:
#
#       -DCMAKE_BUILD_TYPE=Debug|RelWithDebInfo|Release|Production
#       -DCMAKE_INSTALL_PREFIX=/path/to/install
#
#       -DCMAKE_MODULE_PATH=/path/to/ecbuild/cmake

cmake_minimum_required( VERSION 2.8.4 FATAL_ERROR )

project( grib_api C )

set( CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake" ${CMAKE_MODULE_PATH} "${CMAKE_CURRENT_SOURCE_DIR}/../ecbuild/cmake")

include( ecbuild_system )

ecbuild_requires_macro_version( 1.7 )

###############################################################################
# local project

ecbuild_declare_project()

###############################################################################
# some variables/options of this project

ecbuild_add_option( FEATURE EXAMPLES
    DESCRIPTION "Build the examples"
    DEFAULT ON
)

ecbuild_add_option( FEATURE JPG
    DESCRIPTION "support for JPG decoding/encoding"
    DEFAULT ON
)

ecbuild_add_option( FEATURE PNG
    DESCRIPTION "support for PNG decoding/encoding"
    DEFAULT OFF
    REQUIRED_PACKAGES PNG
)

if( HAVE_PNG )
    set( HAVE_LIBPNG 1 ) # compatibility with autotools
    add_definitions( ${PNG_DEFINITIONS} )
else()
    set( HAVE_LIBPNG 0 )
endif()

ecbuild_add_option( FEATURE NETCDF
    DESCRIPTION "support for GRIB to NetCDF conversion"
    DEFAULT ON
    REQUIRED_PACKAGES NetCDF
)

ecbuild_add_option( FEATURE AEC
    DESCRIPTION "support for Adaptive Entropy Coding"
    DEFAULT OFF
    REQUIRED_PACKAGES AEC
)

ecbuild_add_option( FEATURE PYTHON
    DESCRIPTION "build the GRIB_API Python interface"
    DEFAULT ON
	# REQUIRED_LANGUAGES Python # TODO
)

ecbuild_add_option( FEATURE FORTRAN
    DESCRIPTION "build the GRIB_API Fortran interface"
    DEFAULT ON
	# REQUIRED_LANGUAGES Fortran # TODO
)

# TODO Remove this after REQUIRED_LANGUAGES
if( ENABLE_FORTRAN )
    # will set EC_HAVE_FORTRAN with the result
    ecbuild_enable_fortran( MODULE_DIRECTORY ${PROJECT_BINARY_DIR}/fortran/modules )
    set( HAVE_FORTRAN ${EC_HAVE_FORTRAN} )
else()
	set( HAVE_FORTRAN 0 )
endif()

# advanced options (not visible in cmake-gui )

ecbuild_add_option( FEATURE MEMORY_MANAGEMENT DESCRIPTION "enable memory management" DEFAULT OFF ADVANCED )
ecbuild_add_option( FEATURE ALIGN_MEMORY      DESCRIPTION "enable memory alignment"  DEFAULT OFF ADVANCED )

ecbuild_add_option( FEATURE GRIB_TIMER       DESCRIPTION "enable timer"   DEFAULT OFF ADVANCED )
ecbuild_add_option( FEATURE GRIB_THREADS     DESCRIPTION "enable threads" DEFAULT OFF ADVANCED )

###############################################################################
# macro processing

set( GRIB_API_EXTRA_LIBRARIES    "" )
set( GRIB_API_EXTRA_INCLUDE_DIRS "" )
set( GRIB_API_EXTRA_DEFINITIONS  "" )

find_package( CMath )

### JPG support

set( HAVE_JPEG 0 )
set( HAVE_LIBJASPER 0 )
set( HAVE_LIBOPENJPEG 0 )

if( ENABLE_JPG )

    ecbuild_add_extra_search_paths( jasper ) # help standard cmake macro with ecmwf paths
    find_package( Jasper )

    find_package( OpenJPEG )

    if( JASPER_FOUND )
        set( HAVE_JPEG 1 )
        set( HAVE_LIBJASPER 1 )
    endif()

    if( OpenJPEG_FOUND )
        set( HAVE_JPEG 1 )
        set( HAVE_LIBOPENJPEG 1 )
    endif()

endif()


###############################################################################
# other options

if( GRIB_TIMER )
    set( GRIB_TIMER 1 )
else()
    set( GRIB_TIMER 0 )
endif()

set( IS_BIG_ENDIAN 0 )
if( EC_BIG_ENDIAN )
    set( IS_BIG_ENDIAN 1 )
endif()

set( MANAGE_MEM 0 )
if( ENABLE_MEMORY_MANAGEMENT )
    set( MANAGE_MEM 1 )
endif()

set( CMAKE_THREAD_PREFER_PTHREAD 1 ) # find thread library, but prefer pthreads
find_package(Threads REQUIRED)

# debug
message(STATUS " CMAKE_THREAD_LIBS_INIT=${CMAKE_THREAD_LIBS_INIT}")
message(STATUS " CMAKE_USE_PTHREADS_INIT=${CMAKE_USE_PTHREADS_INIT}")
message(STATUS " GRIB_THREADS=${GRIB_THREADS}, HAVE_GRIB_THREADS=${HAVE_GRIB_THREADS}")

if( NOT ${CMAKE_USE_PTHREADS_INIT} )
    message( FATAL_ERROR "Only pthreads supported - thread library found is [${CMAKE_THREAD_LIBS_INIT}]" )
endif()

set( GRIB_PTHREADS 0 )
set( GRIB_LINUX_PTHREADS 0 )
#if( HAVE_GRIB_THREADS AND CMAKE_THREAD_LIBS_INIT )
if( HAVE_GRIB_THREADS )
    if( CMAKE_USE_PTHREADS_INIT )
        set( GRIB_PTHREADS 1 )
        if( ${CMAKE_SYSTEM_NAME} MATCHES "Linux" )
            set( GRIB_LINUX_PTHREADS 1 )
        endif()
    endif()
endif()
message(STATUS " GRIB_PTHREADS=${GRIB_PTHREADS}")

set( GRIB_MEM_ALIGN 0 )
if( ENABLE_ALIGN_MEMORY )
  set( GRIB_MEM_ALIGN 1 )
endif()

# fix for #if IEEE_LE or IEE_BE instead of #ifdef

if( IEEE_BE )
    set( IEEE_LE 0 )
endif()

if( IEEE_LE )
    set( IEEE_BE 0 )
endif()

###############################################################################
# contents

if( NOT ${DEVELOPER_MODE} )
    set( grib_api_default_data_prefix ${CMAKE_INSTALL_PREFIX} )
else()
    set( grib_api_default_data_prefix ${CMAKE_BINARY_DIR} )
endif()

if( NOT DEFINED GRIB_API_DEFINITION_PATH )
    set( GRIB_API_DEFINITION_PATH ${grib_api_default_data_prefix}/share/grib_api/definitions )
endif()
if( NOT DEFINED GRIB_API_SAMPLES_PATH )
    set( GRIB_API_SAMPLES_PATH ${grib_api_default_data_prefix}/share/grib_api/samples )
endif()
if( NOT DEFINED GRIB_API_IFS_SAMPLES_PATH )
    set( GRIB_API_IFS_SAMPLES_PATH ${grib_api_default_data_prefix}/share/grib_api/ifs_samples )
endif()

### config header

ecbuild_generate_config_headers()

configure_file( grib_api_config.h.in grib_api_config.h )

add_definitions( -DHAVE_GRIB_API_CONFIG_H )

install( FILES ${CMAKE_CURRENT_BINARY_DIR}/grib_api_config.h DESTINATION ${INSTALL_INCLUDE_DIR} )

if( CMAKE_COMPILER_IS_GNUCC )
    cmake_add_c_flags("-pedantic")
endif()

############################################################################################
# contents

### export package to other ecbuild packages

set( GRIB_API_TPLS            AEC PNG Jasper OpenJPEG CMath )
set( GRIB_API_INCLUDE_DIRS    ${CMAKE_CURRENT_BINARY_DIR} ${CMAKE_CURRENT_SOURCE_DIR}/src ${CMAKE_CURRENT_BINARY_DIR}/src )
set( GRIB_API_LIBRARIES       grib_api )

get_directory_property( COMPILE_DEFINITIONS GRIB_API_DEFINITIONS )

foreach( _tpl ${GRIB_API_TPLS} )
    string( TOUPPER ${_tpl} TPL )
    if( ${TPL}_FOUND )
        list( APPEND GRIB_API_EXTRA_DEFINITIONS   ${${TPL}_DEFINITIONS} )
        list( APPEND GRIB_API_EXTRA_INCLUDE_DIRS  ${${TPL}_INCLUDE_DIRS} ${${TPL}_INCLUDE_DIR} )
        list( APPEND GRIB_API_EXTRA_LIBRARIES     ${${TPL}_LIBRARIES} )
    endif()
endforeach()

### include directories

include_directories( ${GRIB_API_INCLUDE_DIRS}  ${GRIB_API_EXTRA_INCLUDE_DIRS} )

add_subdirectory( src )
add_subdirectory( tools )
add_subdirectory( fortran )
add_subdirectory( python )
add_subdirectory( definitions )
add_subdirectory( tests )
add_subdirectory( tigge )
add_subdirectory( examples )
add_subdirectory( data )
add_subdirectory( samples )
add_subdirectory( ifs_samples ) # must come after samples

# ecbuild_dont_pack( DIRS samples DONT_PACK_REGEX "*.grib" )
ecbuild_dont_pack( DIRS
     concepts tests.ecmwf doxygen examples.dev templates sms parameters java
     gaussian_experimental gribex examples/F77
     examples/extra bamboo definitions/bufr use fortran/fortranCtypes tigge/tools share/grib_api
     src/.deps tests/.deps tools/.deps tigge/.deps examples/C/.deps examples/python/.deps
     python/.deps fortran/.deps
)

add_custom_target(dist COMMAND ${CMAKE_MAKE_PROGRAM} package_source)

############################################################################################
# export to other projects

# temporary -- add support for ecbuild 1.0.x sub-project inclusion
# to remove once mars server & client use eckit & ecbuild >= 1.1

if( EC_HAVE_FORTRAN )
    list( APPEND GRIB_API_INCLUDE_DIRS  ${CMAKE_Fortran_MODULE_DIRECTORY} )
    list( APPEND GRIB_API_LIBRARIES grib_api_f77 grib_api_f90 )
endif()

if( NOT PROJECT_NAME STREQUAL CMAKE_PROJECT_NAME )
    set( GRIB_API_DEFINITIONS     ${GRIB_API_DEFINITIONS}  PARENT_SCOPE )# includes already TPL definitions
    set( GRIB_API_INCLUDE_DIRS    ${GRIB_API_INCLUDE_DIRS} ${GRIB_API_EXTRA_INCLUDE_DIRS} PARENT_SCOPE )
    set( GRIB_API_LIBRARIES       ${GRIB_API_LIBRARIES}    ${GRIB_API_EXTRA_LIBRARIES} ${CMATH_LIBRARIES} PARENT_SCOPE )
    set( GRIB_API_FOUND           TRUE PARENT_SCOPE )
    set( GRIB_API_SAMPLES_PATH     ${GRIB_API_SAMPLES_PATH} PARENT_SCOPE )
    set( GRIB_API_IFS_SAMPLES_PATH ${GRIB_API_IFS_SAMPLES_PATH} PARENT_SCOPE )
    set( GRIB_API_DEFINITION_PATH  ${GRIB_API_DEFINITION_PATH} PARENT_SCOPE )
endif()

# pkg-config
ecbuild_pkgconfig(
  NAME                grib_api
  URL                 "https://software.ecmwf.int/wiki/display/GRIB/"
  DESCRIPTION         "The GRIB API library"
  LIBRARIES           grib_api
  VARIABLES           HAVE_JPG HAVE_LIBJASPER HAVE_GRIB_THREADS HAVE_NETCDF
                      HAVE_PYTHON HAVE_FORTRAN HAVE_PNG HAVE_AEC
)
if( EC_HAVE_FORTRAN )
 ecbuild_pkgconfig(
   NAME                grib_api_f90
   URL                 "https://software.ecmwf.int/wiki/display/GRIB/"
   LIBRARIES           grib_api_f90 grib_api
   DESCRIPTION         "The GRIB API library for Fortran 90"
   IGNORE_INCLUDE_DIRS ${CMAKE_CURRENT_SOURCE_DIR}/fortran ${PROJECT_BINARY_DIR}/fortran
   VARIABLES           HAVE_JPG HAVE_LIBJASPER HAVE_GRIB_THREADS HAVE_NETCDF
                       HAVE_PYTHON HAVE_PNG HAVE_AEC
 )
  ecbuild_pkgconfig(
   NAME                grib_api_f77
   URL                 "https://software.ecmwf.int/wiki/display/GRIB/"
   LIBRARIES           grib_api_f77 grib_api
   DESCRIPTION         "The GRIB API library for Fortran 77"
   IGNORE_INCLUDE_DIRS ${CMAKE_CURRENT_SOURCE_DIR}/fortran ${PROJECT_BINARY_DIR}/fortran
   VARIABLES           HAVE_JPG HAVE_LIBJASPER HAVE_GRIB_THREADS HAVE_NETCDF
                       HAVE_PYTHON HAVE_PNG HAVE_AEC
 )
endif()

############################################################################################
# finalize

ecbuild_install_project( NAME ${CMAKE_PROJECT_NAME} )

ecbuild_print_summary()

message("")
message("   +---------------------------+")
message("   |  GRIB API version ${GRIB_API_VERSION}  |")
message("   |  Configuration completed  |")
message("   +---------------------------+")
message("")
message("   You can now do 'make' to compile the package, 'ctest' to test it and 'make install' to install it afterwards.")
message("")

=== data/CMakeLists.txt ===
# data/CMakeLists.txt
add_subdirectory(tigge)

# Download all the binary GRIB data from website

file(READ "grib_data_files.txt" files_to_download)
string(REGEX REPLACE "\n" ";" files_to_download "${files_to_download}")
if( HAVE_AEC )
    list(APPEND files_to_download ccsds.grib2)
endif()


# Download all data files doing md5 check on each
ecbuild_get_test_multidata( TARGET get_gribs
                            NAMES ${files_to_download} )

# Copy other files - e.g. reference data, text files etc from the source data dir
LIST(APPEND other_files
    60_model_levels
    bitmap.diff
    ieee_test.good
    index.ok
    index_f90.ok
    julian.out.good
    list_points
    local.good.log
    ls.log
    multi.ok
    multi_step.txt
    no_bitmap.diff
    read_any.ok
    scan_x_regular_gg_5_7_good.dump
    scan_x_regular_ll_5_4_good.dump
    scan_x_regular_ll_5_7_good.dump
    scan_x_regular_ll_8_4_good.dump
    scan_x_regular_ll_8_7_good.dump
    scan_x_rotated_ll_5_4_good.dump
    scan_x_rotated_ll_5_7_good.dump
    scan_x_rotated_ll_8_4_good.dump
    scan_x_rotated_ll_8_7_good.dump
    scan_y_regular_ll_5_4_good.dump
    scan_y_regular_ll_5_7_good.dump
    scan_y_regular_ll_8_4_good.dump
    scan_y_regular_ll_8_7_good.dump
    scan_y_rotated_ll_5_4_good.dump
    scan_y_rotated_ll_5_7_good.dump
    scan_y_rotated_ll_8_4_good.dump
    scan_y_rotated_ll_8_7_good.dump
    spherical_model_level.grib1.good
    spherical_model_level.grib1_32.good
    statistics.out.good
    step.log
    step_grib1.filter
    step_grib1.log
    typeOfProcessedData.ok
    tigge_pf_ecmwf.grib2.ref
)

foreach( file ${other_files} )
   execute_process( COMMAND ${CMAKE_COMMAND} -E copy_if_different ${CMAKE_CURRENT_SOURCE_DIR}/${file} ${CMAKE_CURRENT_BINARY_DIR} )
endforeach()

# Another dummy target which depends on all previous targets
#add_custom_target( get_gribs ALL DEPENDS ${tgts} )
#add_custom_target( get_gribs DEPENDS ${tgts} )

=== definitions/CMakeLists.txt ===
file( GLOB definition_files RELATIVE ${CMAKE_CURRENT_SOURCE_DIR} "*.def" )
file( GLOB table_files RELATIVE ${CMAKE_CURRENT_SOURCE_DIR} "*.table" )

install( FILES ${definition_files} ${table_files}
         DESTINATION share/${PROJECT_NAME}/definitions
         PERMISSIONS OWNER_WRITE OWNER_READ GROUP_READ WORLD_READ )

install( FILES installDefinitions.sh
         DESTINATION share/${PROJECT_NAME}/definitions)

install(  DIRECTORY budg cdf common grib1 grib2 gts mars tide hdf5 wrap
          DESTINATION share/${PROJECT_NAME}/definitions
          FILES_MATCHING
          PATTERN "*.def"
          PATTERN "*.table"
          PATTERN "4.2.192.*.table" EXCLUDE
          PERMISSIONS OWNER_WRITE OWNER_READ GROUP_READ WORLD_READ )

# link to the definitions
file( MAKE_DIRECTORY ${CMAKE_BINARY_DIR}/share/${PROJECT_NAME} )
if( NOT EXISTS "${CMAKE_BINARY_DIR}/share/${PROJECT_NAME}/definitions" )
  execute_process( COMMAND "${CMAKE_COMMAND}" "-E" "create_symlink"
    "${CMAKE_CURRENT_SOURCE_DIR}"
    "${CMAKE_BINARY_DIR}/share/${PROJECT_NAME}/definitions" )
endif()

=== ifs_samples/CMakeLists.txt ===
add_subdirectory( grib1 )

add_subdirectory( grib1_mlgrib2 )

# add_subdirectory( grib1_mlgrib2_ieee32 )

add_subdirectory( grib1_mlgrib2_ieee64 )

=== python/CMakeLists.txt ===
if( HAVE_PYTHON )

    ecbuild_find_python( VERSION 2.5)

    #find_package( SWIG )
    #if( SWIG_FOUND )
    #    include( ${SWIG_USE_FILE} )
    #endif()

    # check for Numpy
    find_package( NumPy )

    ###############################################################################
    # swig python interface

    #if( HAVE_PYTHON AND SWIG_FOUND AND PYTHONLIBS_FOUND )
    if( HAVE_PYTHON AND PYTHONLIBS_FOUND )

        set(PYTHON_DEST "${INSTALL_LIB_DIR}/python${PYTHON_VERSION_MAJOR}.${PYTHON_VERSION_MINOR}/site-packages/grib_api" )

	    file( RELATIVE_PATH relative_rpath "${CMAKE_INSTALL_PREFIX}/${PYTHON_DEST}" "${${PNAME}_FULL_INSTALL_LIB_DIR}" )

		# debug_var( relative_rpath )

        ecbuild_append_to_rpath( ${relative_rpath} )
        ecbuild_append_to_rpath( "../../lib" )        # for ctest to find the libs

        # preparing for generating setup.py -- this may not be needed as cmake can do the swig + shared libs without libtool

        if( NUMPY_FOUND )
            set( DATA_HANDLER "numpy" )
        else()
            set( DATA_HANDLER "array" )
        endif()
        set( _swig_c_wrapper  swig_wrap_${DATA_HANDLER}.c )
        set( _swig_py_wrapper swig_wrap_${DATA_HANDLER}.py )

        set( BUILD_DIR "${PROJECT_SOURCE_DIR}" ) # setup.py assumes build_dir is same as source_dir -- not true for cmake builds

        set( LIB_PNG "${HAVE_LIBPNG}" )

        set( LIB_JASPER ${HAVE_LIBJASPER} )
        if( HAVE_LIBJASPER )
            get_filename_component(JASPER_DIR ${JASPER_INCLUDE_DIR} PATH )
        endif()

        set( LIB_OPENJPEG ${HAVE_LIBOPENJPEG} )
        if( HAVE_LIBOPENJPEG )
            get_filename_component(OPENJPEG_DIR ${OPENJPEG_INCLUDE_DIR} PATH )
        endif()

        include_directories( ${CMAKE_CURRENT_SOURCE_DIR} ${CMAKE_CURRENT_BINARY_DIR} ${PYTHON_INCLUDE_DIRS} )

        configure_file( setup.py.in setup.py )

        # compile swig interface

        set(CMAKE_SWIG_FLAGS "")

        include_directories( ${PYTHON_INCLUDE_PATH} )

        set_source_files_properties( gribapi_swig.i PROPERTIES C ON )

        if( NUMPY_FOUND )
            set( CMAKE_SWIG_FLAGS "-DNUMPY" )
            include_directories( ${NUMPY_INCLUDE_DIRS} )
        endif()

        # Invoke swig to generate the C wrapper
        #  swig_add_module( gribapi_swig python grib_interface.h grib_interface.c gribapi_swig.i )
        #  swig_link_libraries( gribapi_swig grib_api ${PYTHON_LIBRARIES} )

        ####### Do not invoke swig. Use our own generated C wrapper file ######
        ecbuild_add_library(TARGET    _gribapi_swig
                            TYPE SHARED
                            NOINSTALL
                            SOURCES   grib_interface.h grib_interface.c ${_swig_c_wrapper}
                            LIBS      grib_api ${PYTHON_LIBRARIES} )
        # Don't use the lib prefix.  This is needed for the python case where a _modulename.so is generated
        set_target_properties(_gribapi_swig PROPERTIES PREFIX "")

        # Copy the wrapper python file to build area
        set( _swig_py  gribapi_swig.py )
        add_custom_command(
           OUTPUT ${_swig_py}
           COMMAND ${CMAKE_COMMAND} -E copy ${CMAKE_CURRENT_SOURCE_DIR}/${_swig_py_wrapper} ${CMAKE_CURRENT_BINARY_DIR}/${_swig_py}
           DEPENDS _gribapi_swig
        )
        add_custom_target(copy_swig_py ALL DEPENDS ${_swig_py})
        #######################

        install(TARGETS _gribapi_swig DESTINATION ${PYTHON_DEST} )

        install(FILES ${CMAKE_CURRENT_BINARY_DIR}/gribapi_swig.py  DESTINATION ${PYTHON_DEST})
        install(FILES gribapi.py DESTINATION ${PYTHON_DEST})

    endif()

endif()

=== src/CMakeLists.txt ===
list( APPEND grib_api_srcs
    grib_api.h
    action.c
    action_class_alias.c
    action_class_gen.c
    action_class_if.c
    action_class_switch.c
    grib_accessor_class_g1fcperiod.c
    grib_accessor_class_g1end_of_interval_monthly.c
    grib_accessor_class_mars_param.c
    action_class_section.c
    action_class_list.c
    action_class_while.c
    action_class_put.c
    action_class_meta.c
    action_class_remove.c
    action_class_assert.c
    action_class_template.c
    action_class_trigger.c
    action_class_when.c
    action_class_concept.c
    action_class_set.c
    action_class_set_darray.c
    action_class_set_iarray.c
    action_class_noop.c
    action_class_write.c
    action_class_print.c
    action_class_variable.c
    action_class_modify.c
    grib_accessor.c
    grib_concept.c
    grib_darray.c
    grib_iarray.c
    grib_accessor_class_array.c
    grib_accessor_class_assert.c
    grib_accessor_class_ascii.c
    grib_accessor_class_bit.c
    grib_accessor_class_bitmap.c
    grib_accessor_class_bits.c
    grib_accessor_class_bits_per_value.c
    grib_accessor_class_g1bitmap.c
    grib_accessor_class_g2bitmap.c
    grib_accessor_class_concept.c
    grib_accessor_class_decimal_precision.c
    grib_accessor_class_divdouble.c
    grib_accessor_class_budgdate.c
    grib_accessor_class_validity_date.c
    grib_accessor_class_validity_time.c
    grib_accessor_class_bytes.c
    grib_accessor_class.c
    grib_accessor_class_change_scanning_direction.c
    grib_accessor_class_codeflag.c
    grib_accessor_class_codetable.c
    grib_accessor_class_codetable_units.c
    grib_accessor_class_codetable_title.c
    grib_accessor_class_count_file.c
    grib_accessor_class_count_total.c
    grib_accessor_class_double.c
    grib_accessor_class_element.c
    grib_accessor_class_evaluate.c
    grib_accessor_class_g1area.c
    grib_accessor_class_g1date.c
    grib_accessor_class_g1monthlydate.c
    grib_accessor_class_library_version.c
    grib_accessor_class_when.c
    grib_accessor_class_g1verificationdate.c
    grib_accessor_class_g1day_of_the_year_date.c
    grib_accessor_class_g1_half_byte_codeflag.c
    grib_accessor_class_g1forecastmonth.c
    grib_accessor_class_g1step_range.c
    grib_accessor_class_g2step_range.c
    grib_accessor_class_data_g22order_packing.c
    grib_accessor_class_mars_step.c
    grib_accessor_class_g1param.c
    grib_accessor_class_g1p1p2.c
    grib_accessor_class_g1_increment.c
    grib_accessor_class_latlon_increment.c
    grib_accessor_class_g2date.c
    grib_accessor_class_g2level.c
    grib_accessor_class_g2step.c
    grib_accessor_class_g2end_step.c
    grib_accessor_class_g2latlon.c
    grib_accessor_class_g2lon.c
    grib_accessor_class_global_gaussian.c
    grib_accessor_class_gaussian_grid_name.c
    grib_accessor_class_gen.c
    grib_accessor_class_getenv.c
    grib_accessor_class_gts_header.c
    grib_accessor_class_ifs_param.c
    grib_accessor_class_julian_day.c
    grib_accessor_class_latlonvalues.c
    grib_accessor_class_latitudes.c
    grib_accessor_class_longitudes.c
    grib_accessor_class_missing.c
    grib_accessor_class_offset_file.c
    grib_accessor_class_scale.c
    grib_accessor_class_from_scale_factor_scaled_value.c
    grib_accessor_class_times.c
    grib_accessor_class_forward.c
    grib_accessor_class_g2bitmap_present.c
    grib_accessor_class_ibmfloat.c
    grib_accessor_class_ieeefloat.c
    grib_accessor_class_constant.c
    grib_accessor_class_iterator.c
    grib_accessor_class_message.c
    grib_accessor_class_nearest.c
    grib_accessor_class_box.c
    grib_accessor_class_ksec1expver.c
    grib_accessor_class_laplacian.c
    grib_accessor_class_label.c
    grib_accessor_class_long.c
    grib_accessor_class_lookup.c
    grib_accessor_class_octahedral_gaussian.c
    grib_accessor_class_octect_number.c
    grib_accessor_class_headers_only.c
    grib_accessor_class_padding.c
    grib_accessor_class_pad.c
    grib_accessor_class_padto.c
    grib_accessor_class_padtoeven.c
    grib_accessor_class_padtomultiple.c
    grib_accessor_class_section_padding.c
    grib_accessor_class_section_pointer.c
    grib_accessor_class_position.c
    grib_accessor_class_signed.c
    grib_accessor_class_signed_bits.c
    grib_accessor_class_section.c
    grib_accessor_class_step_in_units.c
    grib_accessor_class_section_length.c
    grib_accessor_class_g1_message_length.c
    grib_accessor_class_g1_section4_length.c
    grib_accessor_class_size.c
    grib_accessor_class_scale_values.c
    grib_accessor_class_offset_values.c
    grib_accessor_class_sprintf.c
    grib_accessor_class_round.c
    grib_accessor_class_spectral_truncation.c
    grib_accessor_class_time.c
    grib_accessor_class_transient.c
    grib_accessor_class_values.c
    grib_accessor_class_simple_packing_error.c
    grib_accessor_class_data_simple_packing.c
    grib_accessor_class_count_missing.c
    grib_accessor_class_data_sh_packed.c
    grib_accessor_class_data_sh_unpacked.c
    grib_accessor_class_number_of_values_data_raw_packing.c
    grib_accessor_class_data_g1simple_packing.c
    grib_accessor_class_data_g1shsimple_packing.c
    grib_accessor_class_data_shsimple_packing.c
    grib_accessor_class_data_constant_field.c
    grib_accessor_class_data_dummy_field.c
    grib_2order_packer_simple.c
    grib_accessor_class_variable.c
    grib_accessor_class_second_order_bits_per_value.c
    grib_accessor_class_data_g2simple_packing.c
    grib_accessor_class_data_g2simple_packing_with_preprocessing.c
    grib_accessor_class_data_g2shsimple_packing.c
    grib_accessor_class_data_g2complex_packing.c
    grib_accessor_class_data_2order_packing.c
    grib_accessor_class_data_2order_packing_count.c
    grib_accessor_class_data_g1second_order_row_by_row_packing.c
    grib_accessor_class_data_g1second_order_constant_width_packing.c
    grib_accessor_class_data_g1second_order_general_packing.c
    grib_accessor_class_data_g1second_order_general_extended_packing.c
    grib_accessor_class_g2grid.c
    grib_accessor_class_data_apply_bitmap.c
    grib_accessor_class_data_apply_boustrophedonic.c
	grib_accessor_class_data_apply_boustrophedonic_bitmap.c
    grib_accessor_class_data_secondary_bitmap.c
    grib_accessor_class_data_g1secondary_bitmap.c
    grib_accessor_class_data_g2secondary_bitmap.c
    grib_accessor_class_data_jpeg2000_packing.c
    grib_accessor_class_data_png_packing.c
    grib_accessor_class_data_ccsds_packing.c
    grib_accessor_class_data_raw_packing.c
    grib_accessor_class_data_complex_packing.c
    grib_accessor_class_data_g1complex_packing.c
    grib_accessor_class_gds_not_present_bitmap.c
    grib_accessor_class_data_apply_gdsnotpresent.c
    grib_accessor_class_gds_is_present.c
    grib_accessor_class_select_step_template.c
    grib_accessor_class_local_definition.c
    grib_accessor_class_g2_eps.c
    grib_accessor_class_g2_chemical.c
    grib_accessor_class_g2_mars_labeling.c
    grib_accessor_class_md5.c
    grib_jasper_encoding.c
    grib_openjpeg_encoding.c
    action_class_set_missing.c
    grib_accessor_class_number_of_points.c
    grib_accessor_class_suppressed.c
    grib_index.c
    grib_accessor_class_number_of_points_gaussian.c
    grib_accessor_class_number_of_values.c
    grib_accessor_class_number_of_coded_values.c
    grib_accessor_class_g1number_of_coded_values_sh_complex.c
    grib_accessor_class_g1number_of_coded_values_sh_simple.c
    grib_accessor_class_dirty.c
    grib_accessor_class_statistics.c
    grib_accessor_class_statistics_spectral.c
    grib_accessor_class_unsigned.c
    grib_accessor_class_unsigned_bits.c
    grib_accessor_class_spd.c
    grib_accessor_class_sum.c
    grib_accessor_class_vector.c
    grib_accessor_class_long_vector.c
    grib_gaussian_reduced.c
    grib_accessor_class_abstract_vector.c
    grib_accessor_class_abstract_long_vector.c
    grib_loader_from_handle.c
    grib_bits.c
    grib_timer.c
    grib_ibmfloat.c
    grib_ieeefloat.c
    grib_accessor_class_reference_value_error.c
    grib_memory.c
    grib_buffer.c
    grib_dumper.c
    grib_dumper_class_serialize.c
    grib_dumper_class_debug.c
    grib_dumper_class_default.c
    grib_dumper_class_keys.c
    grib_dumper_class_json.c
    grib_dumper_class_c_code.c
    grib_dumper_class_wmo.c
    grib_dumper_class.c
    grib_context.c
    grib_date.c
    grib_fieldset.c
    grib_filepool.c
    grib_geography.c
    grib_handle.c
    grib_header_compute.c
    grib_hash_keys.c
    grib_io.c
    grib_trie.c
    grib_itrie.c
    grib_rules.c
    grib_keys_iterator.c
    grib_parse_utils.c
    grib_query.c
    grib_scaling.c
    grib_templates.c
    grib_dependency.c
    grib_value.c
    grib_errors.c
    grib_expression_class_binop.c
    grib_expression_class_true.c
    grib_expression_class_string_compare.c
    grib_expression_class_unop.c
    grib_expression_class_functor.c
    grib_expression_class_accessor.c
    grib_expression_class_long.c
    grib_expression_class_double.c
    grib_expression_class_string.c
    grib_box.c
    grib_box_class.c
    grib_box_class_gen.c
    grib_box_class_regular_gaussian.c
    grib_box_class_reduced_gaussian.c
    grib_nearest.c
    grib_nearest_class.c
    grib_nearest_class_gen.c
    grib_nearest_class_regular.c
    grib_nearest_class_reduced.c
    grib_nearest_class_latlon_reduced.c
    grib_nearest_class_sh.c
	grib_nearest_class_lambert_conformal.c
    grib_iterator_class_polar_stereographic.c
    grib_iterator_class_lambert_azimuthal_equal_area.c
    grib_iterator_class_lambert_conformal.c
    grib_iterator.c
    grib_iterator_class.c
    grib_iterator_class_gaussian.c
    grib_iterator_class_gaussian_reduced.c
    grib_iterator_class_latlon_reduced.c
    grib_iterator_class_gen.c
    grib_iterator_class_latlon.c
    grib_iterator_class_regular.c
    grib_expression.c
    grib_util.c
    compile.c
    functions.c
    grib_accessor_class.h
    grib_accessor_factory.h
    grib_api_internal.h
    grib_api_prototypes.h
    grib_box_class.h
    grib_box_factory.h
    grib_dumper_class.h
    grib_dumper_factory.h
    grib_emoslib.h
    grib_expression.h
    grib_iterator_class.h
    grib_iterator_factory.h
    grib_nearest_class.h
    grib_nearest_factory.h
    grib_templates.h
    grib_yacc.h
    md5.h
    md5.c
    grib_accessor_class_int16.c
    grib_accessor_class_int16_little_endian.c
    grib_accessor_class_int32.c
    grib_accessor_class_int32_little_endian.c
    grib_accessor_class_int64.c
    grib_accessor_class_int64_little_endian.c
    grib_accessor_class_int8.c
    grib_accessor_class_uint16.c
    grib_accessor_class_uint16_little_endian.c
    grib_accessor_class_uint32.c
    grib_accessor_class_uint32_little_endian.c
    grib_accessor_class_uint64.c
    grib_accessor_class_uint64_little_endian.c
    grib_accessor_class_uint8.c
    grib_accessor_class_blob.c
	grib_api_windef.h
    # We ship our own generated lex/yacc C files
    grib_yacc.c  grib_lex.c
)

list( APPEND grib_api_extra_srcs
    grib_bits_fast_big_endian.c grib_bits_any_endian.c
    grib_bits_fast_big_endian_vector.c grib_bits_any_endian_vector.c
    grib_bits_fast_big_endian_simple.c grib_bits_any_endian_simple.c
    grib_bits_fast_big_endian_omp.c grib_bits_any_endian_omp.c
    encode_double_array.c
    grib_bits_ibmpow.c
    grib_bits_ibmpow_opt.c
    minmax_val.c
)

configure_file( grib_api_version.c.in grib_api_version.c @ONLY )
configure_file( grib_api_version.h.in grib_api_version.h @ONLY )

# We ship our own generated lex/yacc C files
#ecbuild_generate_yy(YYPREFIX  grib_yy
#                    YACC      griby
#                    LEX       gribl
#                    FLEX_FLAGS " "
#                    LEX_FLAGS  " "
#                    BISON_FLAGS "-y"
#                    YACC_FLAGS  "-y"
#                    DEPENDANT action.c )

ecbuild_add_library(TARGET    grib_api
                    SOURCES   grib_api_version.c
                              # griby.c gribl.c
                             ${grib_api_srcs}

=== tests/CMakeLists.txt ===
# tests/CMakeLists.txt
#
# Configure the file which all CMake tests will include
configure_file( include.ctest.sh.in  include.ctest.sh @ONLY )

# Build the executables used by test scripts
################################################
list( APPEND test_bins
      read_any
      julian
      index
      multi_from_message
      read_index
      unit_tests
      gauss_sub
)

foreach( tool ${test_bins} )
    # here we use the fact that each tool has only one C file that matches its name
    ecbuild_add_executable( TARGET    ${tool}
                            NOINSTALL
                            SOURCES   ${tool}.c
                            LIBS      grib_api
    )
endforeach()

# Now add each test (shell scripts)
#################################################
list( APPEND tests1
    definitions
    calendar
    unit_tests
)
list( APPEND tests2
    ieee
    grib1to2
    grib2to1
    badgrib
    ls
    filter
    multi
    budg
    gridType
    concept
    decimalPrecision
    bitsPerValue
    get_fail
    missing
    local
    step
    set
    iterator
    compare
    level
    index
    bitmap
    list
    second_order
    multi_from_message
    change_scanning
    julian
    statistics
    tigge
    tigge_conversions
    read_any
    padding
    debug
)

# These tests do not require any data downloads
foreach( test ${tests1} )
    ecbuild_add_test( TARGET t_${test}
                  TYPE SCRIPT
                  COMMAND ${CMAKE_CURRENT_SOURCE_DIR}/${test}.sh
                  RESOURCES include.sh utils.sh
    )
endforeach()

# Note: making the test dependent on the grib files (with DEPENDS)
#       means they will be downloaded at "make" time
#       rather than when you do "make test". Use TEST_DEPENDS instead
foreach( test ${tests2} )
    ecbuild_add_test( TARGET t_${test}
                  TYPE SCRIPT
                  # DEPENDS get_gribs get_tigge_gribs
                  COMMAND ${CMAKE_CURRENT_SOURCE_DIR}/${test}.sh
                  RESOURCES include.sh
                  TEST_DEPENDS get_gribs get_tigge_gribs
    )
endforeach()

###########################################
# Note: the reference file is in the tests dir not data dir!
ecbuild_add_test( TARGET t_lamb_az_eq_area
                  TYPE SCRIPT
                  COMMAND ${CMAKE_CURRENT_SOURCE_DIR}/lamb_az_eq_area.sh
                  RESOURCES include.sh lamb_az_eq_area.ref
                  TEST_DEPENDS get_gribs
)

# These ones are conditional
ecbuild_add_test( TARGET t_grib_to_netcdf
                  TYPE SCRIPT
                  CONDITION HAVE_NETCDF
                  COMMAND ${CMAKE_CURRENT_SOURCE_DIR}/grib_to_netcdf.sh
                  RESOURCES include.sh
                  TEST_DEPENDS get_gribs
)

ecbuild_add_test( TARGET t_jpeg
                  TYPE SCRIPT
                  CONDITION HAVE_JPEG
                  COMMAND ${CMAKE_CURRENT_SOURCE_DIR}/jpeg.sh
                  RESOURCES include.sh
                  TEST_DEPENDS get_gribs
)

ecbuild_add_test( TARGET t_ccsds
                  TYPE SCRIPT
                  CONDITION HAVE_AEC
                  COMMAND ${CMAKE_CURRENT_SOURCE_DIR}/ccsds.sh
                  RESOURCES include.sh
                  TEST_DEPENDS get_gribs
)

=== tools/CMakeLists.txt ===
# tools library

ecbuild_add_library( TARGET    grib_tools
                     TYPE      STATIC
                     NOINSTALL
                     SOURCES   grib_tools.c grib_options.c grib_tools.h
                     LIBS      grib_api )

# tools binaries

list( APPEND grib_tools_bins
             grib_keys grib_histogram grib_error grib_add big2gribex
             grib_debug grib_info grib_filter grib_ls grib_dump
             grib2ppm grib_set grib_get grib_get_data grib_copy grib_repair
             grib_packing grib_cmp grib_convert grib_distance grib_corruption_check
             grib_compare grib_parser grib_count grib_index_build 
             gg_sub_area_check grib_moments grib_to_json)

foreach( tool ${grib_tools_bins} )
    # here we use the fact that each tool has only one C file that matches its name
    ecbuild_add_executable( TARGET     ${tool}
                            SOURCES    ${tool}.c
                            LIBS       grib_tools )
endforeach()

# grib to netcdf is optional
ecbuild_add_executable( TARGET     grib_to_netcdf
                        SOURCES    grib_to_netcdf.c
                        INCLUDES   ${NETCDF_INCLUDE_DIRS}
                        CONDITION  HAVE_NETCDF
                        LIBS       grib_tools ${NETCDF_LIBRARIES})


ecbuild_add_executable( TARGET     grib_list_keys
                        SOURCES    list_keys.c
                        LIBS       grib_tools  )


# grib1to2 script needs to be generated before installation
configure_file( grib1to2.in  grib1to2 )
install( FILES ${CMAKE_CURRENT_BINARY_DIR}/grib1to2
         DESTINATION ${INSTALL_BIN_DIR}
         PERMISSIONS OWNER_EXECUTE OWNER_WRITE OWNER_READ
                     GROUP_EXECUTE GROUP_READ
                     WORLD_EXECUTE WORLD_READ )

=== data/tigge/CMakeLists.txt ===
# data/tigge/CMakeLists.txt
# Download all the TIGGE grib data from website

file(READ "tigge_data_files.txt" tigge_files_to_download)
string(REGEX REPLACE "\n" ";" tigge_files_to_download "${tigge_files_to_download}")

# Download all data files doing md5 check on each
ecbuild_get_test_multidata( TARGET get_tigge_gribs
                            NAMES ${tigge_files_to_download} )

=== examples/C/CMakeLists.txt ===
# examples/C/CMakeLists.txt

# Configure the file which all CMake tests will include
configure_file( include.ctest.sh.in  include.ctest.sh  @ONLY )


# Build the executables used by test scripts
################################################
list( APPEND test_bins
      nearest
      set_bitmap
      iterator
      get
      print_data
      set
      set_missing
      keys_iterator
      set_data
      mars_param
      values_check
      box
      multi
      multi2
      multi_write
      precision
      set_pv
      list
      get_data
      sections_copy
      iterator_bitmap
      large_grib1
      clone
      check_gaussian_grid
      ensemble_index
)
foreach( tool ${test_bins} )
    ecbuild_add_executable( TARGET    ${tool}
                            NOINSTALL
                            SOURCES   ${tool}.c
                            LIBS      grib_api
    )
endforeach()

# Now add each test (shell scripts)
#################################################
list( APPEND tests
   iterator
   get
   print_data
   set
   keys_iterator
   multi
   multi_write
   precision
   list
   large_grib1
   get_data
   set_missing
   clone
   sections_copy
   set_pv
   check_gaussian_grids
)
foreach( test ${tests} )
    ecbuild_add_test( TARGET c_${test}
                  TYPE       SCRIPT
                  COMMAND    ${CMAKE_CURRENT_SOURCE_DIR}/${test}.sh
                  RESOURCES  include.sh
                  TEST_DEPENDS get_gribs
    )
endforeach()


#############################################
# Tests with no script
ecbuild_add_test( TARGET    c_new_sample
                  SOURCES   new_sample.c
                  LIBS      grib_api
                  ARGS      "out.new_sample.grib"
                  ENVIRONMENT "GRIB_SAMPLES_PATH=${PROJECT_SOURCE_DIR}/samples" "GRIB_DEFINITION_PATH=${PROJECT_SOURCE_DIR}/definitions"
)

=== examples/python/CMakeLists.txt ===
# examples/python/CMakeLists.txt

# Configure the file which all CMake tests will include
configure_file( include.ctest.sh.in  include.ctest.sh  @ONLY )


# Build the executables used by test scripts
################################################
list( APPEND test_bins
   keys_iterator
   print_data
   iterator
   count_messages
)

foreach( tool ${test_bins} )
   ecbuild_add_executable( TARGET    p_${tool}
                           NOINSTALL
                           SOURCES   ${tool}.c
                           CONDITION HAVE_PYTHON
                           LIBS      grib_api
   )
   list( APPEND ptools  p_${tool} )
endforeach()


# Now add each test
#################################################
list( APPEND tests
   clone
   count_messages
   get
   index
   iterator
   keys_iterator
   multi_write
   nearest
   print_data
   samples
   set
   set_missing
   binary_message
   set_bitmap
)
foreach( test ${tests} )
    ecbuild_add_test( TARGET p_${test}_test
                  TYPE       SCRIPT
                  DEPENDS    ${ptools}
                  COMMAND    ${CMAKE_CURRENT_SOURCE_DIR}/${test}.sh
                  CONDITION  HAVE_PYTHON
                  RESOURCES  include.sh ${test}.py
                  ENVIRONMENT PYTHON=${PYTHON_EXECUTABLE}
                  TEST_DEPENDS get_gribs get_tigge_gribs
    )
endforeach()

=== ifs_samples/grib1/CMakeLists.txt ===
set( _basedir grib1 )

list( APPEND ifs_samples_${_basedir}
      gg_ml.tmpl
      gg_sfc.tmpl
      sh_ml.tmpl
      sh_sfc.tmpl
)

install( FILES ${GRIB_API_SAMPLES_FILES} ${ifs_samples_${_basedir}}  
         DESTINATION ${GRIB_API_IFS_SAMPLES_PATH}/${_basedir}
         PERMISSIONS OWNER_WRITE OWNER_READ GROUP_READ WORLD_READ )

file( COPY ${ifs_samples_${_basedir}}
      DESTINATION ${CMAKE_BINARY_DIR}/share/${PROJECT_NAME}/ifs_samples/${_basedir} )

=== debian/changelog ===
grib-api (1.14.4-5) unstable; urgency=medium

  * Add libpng-dev, zlib1g-dev, libjpeg-dev, libjasper-dev to lgrib-api-dev
    dependencies, because cmake build scripts make compiles depend on them.
  * Add patch for Hurd compilation.

 -- Alastair McKinstry <mckinstry@debian.org>  Wed, 13 Jan 2016 08:48:13 +0000

grib-api (1.14.4-4) unstable; urgency=medium

  * Don't record build paths in ecbuild_config.h. Breaks reproducibility.

 -- Alastair McKinstry <mckinstry@debian.org>  Tue, 12 Jan 2016 20:18:55 +0000

grib-api (1.14.4-3) unstable; urgency=medium

  * libgrib-api-dev depends on libaec-dev as it ships dependencies in the
     cmake scripts.
  * Drop chrpath in favor of using ENABLE_RPATH=OFF in cmake
  * Build-Conflict on libgrib-api-dev, to avoid incorrect libs being
    used during testing. Set LD_LIBRARY_PATH during testing to find
    correct libs.

 -- Alastair McKinstry <mckinstry@debian.org>  Tue, 12 Jan 2016 11:05:52 +0000

grib-api (1.14.4-2) unstable; urgency=medium

  * Add /usr/lib/cmake/grib_api/* files to -dev package for magics++
  * Add new binaries to /usr/bin in libgrib-api-tools

 -- Alastair McKinstry <mckinstry@debian.org>  Thu, 07 Jan 2016 04:56:40 +0000

grib-api (1.14.4-1) unstable; urgency=medium

  * New upstream release.

 -- Alastair McKinstry <mckinstry@debian.org>  Tue, 05 Jan 2016 01:35:45 +0000

grib-api (1.14.3-2) unstable; urgency=medium

  * Make builds reproducible.
  * Links libs --as-needed
  * Set DISABLE_OS_CHECK=ON for Hurd, etc.

 -- Alastair McKinstry <mckinstry@debian.org>  Mon, 07 Dec 2015 07:29:31 +0000

=== debian/control ===
Source: grib-api
Section: libdevel
Priority: optional
Maintainer: Enrico Zini <enrico@debian.org>
Uploaders: Alastair McKinstry <mckinstry@debian.org>
Build-Depends: debhelper (>= 9), dh-buildinfo, cmake,
  libjasper-dev, libjpeg-dev, libpng-dev, gfortran, flex, bison, quilt,
  curl, python-all-dev, python-numpy, dh-python,
  libaec-dev
Standards-Version: 3.9.6.0
Build-Conflicts: libgrib-api-dev
X-Python-Version: >= 2.6
Homepage: https://software.ecmwf.int/wiki/display/GRIB/Home
Vcs-Git: git://anonscm.debian.org/collab-maint/gribapi.git
Vcs-Browser: http://anonscm.debian.org/cgit/collab-maint/gribapi.git

Package: libgrib-api0
Section: libs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Replaces: libgrib-api-data (<< 1.9.0~)
Breaks: libgrib-api-data (<< 1.9.0~)
Conflicts: libgrib-api-0d-0, libgrib-api-0d-1, libgrib-api-1.9.9, libgrib-api-1.9.16, libgrib-api-1.10.4
Description: GRIB decoding/encoding software library
 The ECMWF GRIB API is an application program interface accessible from C and
 FORTRAN programs developed for encoding and decoding WMO FM-92 GRIB edition 1
 and edition 2 messages.
 .
 ECMWF is the European Centre for Medium-Range Weather Forecasts.

Package: libgrib-api-dev
Section: libdevel
Architecture: any
Depends: libgrib-api0 (= ${binary:Version}), ${misc:Depends}, 
 libaec-dev, libjasper-dev, libpng-dev, libjpeg-dev, libjasper-dev, zlib1g-dev
Description: GRIB decoding/encoding software library (development)
 The ECMWF GRIB API is an application program interface accessible from C and
 FORTRAN programs developed for encoding and decoding WMO FM-92 GRIB edition 1
 and edition 2 messages.
 .
 ECMWF is the European Centre for Medium-Range Weather Forecasts.
 
Package: libgrib-api-tools
Section: utils
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: GRIB decoding/encoding software (utilities)
 The ECMWF GRIB API is an application program interface accessible from C and
 FORTRAN programs developed for encoding and decoding WMO FM-92 GRIB edition 1
 and edition 2 messages.
 .
 This is a useful set of command line tools to give quick access to grib
 messages.
 .
 ECMWF is the European Centre for Medium-Range Weather Forecasts.

Package: python-gribapi
Section: python
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}, ${python:Depends}
Provides: ${python:Provides}
Description: Python module for the ECMWF GRIB API library
 The ECMWF GRIB API is an application program interface accessible from C and
 FORTRAN programs developed for encoding and decoding WMO FM-92 GRIB edition 1
 and edition 2 messages.
 .
 This is a Python wrapper for the GRIB API library.
 .
 ECMWF is the European Centre for Medium-Range Weather Forecasts.

=== debian/rules ===
#!/usr/bin/make -f

export DEB_LDFLAGS_MAINT_PREPEND := -Wl,-z,defs -Wl,--as-needed

DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
LIBDIR=/usr/lib/$(DEB_HOST_MULTIARCH)
BUILDDIR=$(CURDIR)/debian/build

# For hardening
CPPFLAGS:=$(shell dpkg-buildflags --get CPPFLAGS)
CFLAGS:=$(shell dpkg-buildflags --get CFLAGS) $(CPPFLAGS) #  -fPIC
CXXFLAGS:=$(shell dpkg-buildflags --get CXXFLAGS) $(CPPFLAGS)
LDFLAGS:=$(shell dpkg-buildflags --get LDFLAGS)

export LDFLAGS CFLAGS CXXFLAGS

%:
	dh $@ --buildsystem=cmake --with=python2 --builddirectory=$(BUILDDIR)

override_dh_auto_configure:
	# Disable python modules until we figure out how to build them properly
	F77=gfortran dh_auto_configure -- \
	    -DCMAKE_BUILD_TYPE=Release \
	    -DDISABLE_OS_CHECK=ON \
	    -DENABLE_PNG=ON -DENABLE_PYTHON=ON \
	    -DENABLE_AEC=ON \
	    -DENABLE_RPATHS=OFF \
	    -DHAVE_BIT_REPRODUCIBLE=ON \
	    -DCFLAGS="${CFLAGS} ${LDFLAGS}" \
	    -DENABLE_ALIGN_MEMORY=ON -DENABLE_GRIB_TIMER=ON \
		-DENABLE_GRIB_THREADS=ON 
#	    -DENABLE_MEMORY_MANAGEMENT=ON \

override_dh_auto_test:
	        LD_LIBRARY_PATH=$(CURDIR)/debian/build/lib dh_auto_test 

override_dh_install:
	for d in libgrib_api_f77.so  libgrib_api_f90.so	libgrib_api.so ; do \
		mv debian/tmp/usr/lib/$$d.0 debian/tmp/usr/lib/$$d.0.0.0 ; done
	dh_numpy
	# Make properly visible
	mv debian/tmp/usr/lib/python2.7/site-packages/grib_api debian/tmp/usr/lib/python2.7/site-packages/gribapi
	mv debian/tmp/usr/lib/python2.7/site-packages/gribapi/gribapi.py debian/tmp/usr/lib/python2.7/site-packages/gribapi/__init__.py
	dh_install
	# Setup cmake files for magics++, metview, etc.
	mkdir -p debian/libgrib-api-dev/$(LIBDIR)/cmake/grib_api
	cp debian/tmp/usr/share/grib_api/cmake/* debian/libgrib-api-dev/$(LIBDIR)/cmake/grib_api
	sed -e 's%$${_IMPORT_PREFIX}%/usr%' \
	       < debian/tmp/usr/share/grib_api//cmake/grib_api-targets-release.cmake \
              > debian/libgrib-api-dev/$(LIBDIR)/cmake/grib_api/grib_api-targets-release.cmake

override_dh_auto_clean:
	dh_auto_clean
	# Things that upstream leaves behind
	rm -f python/gribapi.pyc
	rm -f tests/bitmap.rules tests/out.grib1 tests/out.grib2 tests/out.gribidx \
	      tests/rules tests/simple_ieee_test.grib1.txt tests/statistics.filter \
	      tests/statistics.out tests/x.grib \
	      data/change_scanning_rotated_ll.filter examples/F90/index.idx

override_dh_fixperms:
	dh_fixperms
	test -e /usr/bin/dh_buildinfo && dh_buildinfo
